-- This examples show how to use the exit handler. If the script
-- will not terminate normally the exit handler will be called.
--
-- Upload and start the script. Then terminate the script while
-- it is running. Get the output of the script and you will see
-- 'exit handler called'.

require "Pdu"

-- To use the exit handler write a global function at the beginning
-- of the script. 
function ExitHandler()
  -- if you'd like to use objects it's better to generate new 
  -- one instead of using global objects. You do not know when
  -- the event handler will be called and if the global objects
  -- is still available.
  local pdu = pdumodel.Pdu:getDefault()
  local beeper = pdu:getBeeper()
  -- activates the beeper for 100 ms
  beeper:activate(true, "exit called", 100)
  -- print a message
  print("exit handler called")
end

-- just waste time here
for i=1,1000000 do
    for j=1,1000000 do
	waste = "just waste time"
    end
end



