-- get and set settings from an outlet

require "Pdu"

-- create a new agent
local agent = agent.HttpAgent:new("192.168.7.20", "admin", "raritan")
-- get outlet 3 object
-- We get here outlet direct, without to generate a pdu object.
-- This index starts at zero => 2 is the 3rd outlet (well known url)
local out3 = pdumodel.Outlet:newRemote("/model/pdu/0/outlet/2", agent)

-- get settings from outlet 3 and print it
local settings = out3:getSettings()
print("get settings")
printTable(settings) 
print()

-- modify an entry
print("modify settings name")
settings.name = "hello world!!!!"
printTable(settings)
local status = out3:setSettings(settings)
local statusMsg = (status == 0) and 'OK' or 'invalid parameter'
print("set settings returns: " .. statusMsg)
print("print settings")
printTable(out3:getSettings())
print()

-- create the settings table by hand
settings                  = {}
settings.name             = "does it work???"
settings.cycleDelay       = 11
settings.nonCritical      = false
settings.startupState     = 3
settings.usePduCycleDelay = true
settings.sequenceDelay    = 0

-- sets the hand made settings
print("print hand made settings table")
printTable(settings)
status = out3:setSettings(settings)
statusMsg = (status == 0) and 'OK' or 'invalid parameter'
print("set settings returns: " .. statusMsg)
print()
print("get settings from outlet 3")
printTable(out3:getSettings())
print()

-- create a table by hand with just one entry => failure
local wrongSettings = {}
wrongSettings.name = "crash"
print("print wrong settings table")
printTable(wrongSettings)
-- execution of method setSettings() crashes and prints the failure message
status = out3:setSettings(wrongSettings)
