-- alternates the 3rd outlet every second for ten times long

require "Pdu"

-- get remote pdu object
local agent = agent.HttpAgent:new("192.168.7.20", "admin", "raritan")
local pdu = pdumodel.Pdu:newRemote("/model/pdu/0", agent)
-- get outlets vector and get the 3rd entry from the vector
local out3 = pdu:getOutlets()[3]

-- we use here assert to verify that out3 has a value not 'nil'
assert(out3)

print("-- start state dump")
-- Luas ternary operator
local powerstate = (out3:getState().powerState == pdumodel.Outlet.PowerState.PS_ON) and "ON" or "OFF"
local lastChange = os.date("%c", out3:getState().lastPowerStateChange)
print("power state: " .. powerstate)
print("last power state change: " .. lastChange)
print()

for i = 1,10 do
  -- wait for one second
  sleep(1)

  local newPowerstate = nil
  -- get the powerstate
  local oldPowerstate = out3:getState().powerState
  if oldPowerstate == pdumodel.Outlet.PowerState.PS_OFF then
    newPowerstate = pdumodel.Outlet.PowerState.PS_ON
  else
    newPowerstate = pdumodel.Outlet.PowerState.PS_OFF
  end

  -- set the alternated powerstate
  out3:setPowerState(newPowerstate)
  
  powerstate = (out3:getState().powerState == pdumodel.Outlet.PowerState.PS_ON) and "ON" or "OFF"
  lastChange = os.date("%c", out3.lastPowerStateChange)
  print("power state: " .. powerstate)
  print("last power state change: " .. lastChange)
  print()
end
